/*
 *         ""  ""
 *
 */

#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include <getopt.h>

#define ahdd_cyl 255
#define ahdd_head 254
#define ahdd_sec 253
#define ahdd_ld_all 252
#define ahdd_part 251

#define shdd_boot 0
#define shdd_cyl 1
#define shdd_head_sec 2
#define shdd_part 3

#define shdd_nld 0
#define shdd_ld_len 1
#define shdd_adr_boot 2
#define shhd_adr_par 3
#define shdd_page 4

char p_invers = 0;

unsigned short int cyl = 0;
unsigned short int head = 0;
unsigned short int sec = 0;

unsigned short int boot = 2;
unsigned short int ld_all = 0;

unsigned short int ncyl = 0;
unsigned short int nhead = 0;
unsigned short int nsec = 0;

unsigned short int nld = 2;

unsigned short int crc = 012701;

//mbr  
unsigned short int mbr[256] = { 0xA0, 0x15DF, 0xFF87, 0xFFEA, 0x15DF, 0x1C, 0xFFE0, 0x87, 0x0 };

unsigned short int part[256] = { 0 };

unsigned short int buf[256];

long int len = 0;
long int lba = 3;       //   ld  hdd ""

char bkd[] = "c.bkd";
char img[] = "bkhdd.img";

FILE* rfp, * wfp;

//     
int lenfile()
{
  fseek(rfp, 0, SEEK_END);
  len = ftell(rfp);
  printf("lenght = %ld byte,  ", len);
  fseek(rfp, 0, SEEK_SET);
  len += 511;
  len /= 512;
  printf("blocks  = %ld  ", len);
  return (len);
}

//   
unsigned short int invers_buf(unsigned short int *buf)
{
  if (p_invers == '\0') return (0);
  for (int i = 0; i < 256; i++)
      buf[i] = ~buf[i];
  return (0);
}

//    bkd     hdd
//       nsec
int wr_ld()
{
  for (int i = 0; i < len; i++)
    {
      if ((fread(buf, 1, 512, rfp)) != 512)
          printf("  %d    %s \n", i, bkd);
      invers_buf(buf);
      if ((fwrite(buf, 1, 512, wfp)) != 512)
          printf("    %s \n", img);

      if (++nsec == sec)
        {
          nsec = 0;
          if (++nhead == head)
            {
              nhead = 0;
              if (++ncyl > cyl)
                {
                  printf("  \n", img);
                  exit(-1);
                }
            }
        }
    }   
  return (nsec);
}

//     hdd   bkd
void wr_bkd()
{
  for (int i = 0; i < len; i++)
    {
      if ((fread(buf, 1, 512, rfp)) != 512)
          printf("    %s \n", img);
      invers_buf(buf);
      if ((fwrite(buf, 1, 512, wfp)) != 512)
          printf("    %s \n", bkd);
    }
}

//   
// nsec -  
// sec - 
int wr_sectors()
{
  for (int i = 0; i < 256; i++)
      if (p_invers == 0) buf[i] = 0; else buf[i] = 0177777;

  for (int i = nsec; i < sec; i++)
    {
      if ((fwrite(buf, 1, 512, wfp)) != 512)
          printf("    %s \n", img);

      if (++nhead == head)
        {
          nhead = 0;
          if (++ncyl > cyl)
            {
              printf("  \n", img);
              return (-1);
            }
        }
    }
  return (0);
}

//  crc  altpro
unsigned short int crc_alt()
{
  for (int i = 0; i < (ld_all*2 + 4); i++)
      crc += part[255 - i];
  printf("crc =  %d \n", crc);
  return (crc);
}

void
helpdoc()
{
  printf("      0010-11\n");
  printf("\t(c) 2010 Terra software\n\n");

  printf(":  bkhdd -a  -m [-i -cN -hN -sN]\n\n");
  printf("\t/a -    ''\n");
  printf("\t/m -    ''\n");
  printf("\t/i -   \n");
  printf("\t/cN -   ()\n");
  printf("\t/hN -  \n");
  printf("\t/sN -    \n\n");
  printf("  hdd  ,      bkhdd.img\n\n");
  printf("       bkhdd.img,    \n");
  printf("     dd -http://www.chrysocome.net/dd\n");
}

//   hdd   
void bkd_img_alt()
{
  if ((rfp = fopen(bkd, "rb")) == NULL)
    {
      printf("   %s \n", bkd);
      exit(-1);
    }
  if ((wfp = fopen(img, "w+b")) == NULL)
    {
      printf("   %s \n", img);
      exit(-1);
    }

  part[ahdd_cyl] = cyl;
  part[ahdd_head] = head;
  part[ahdd_sec] = sec;

  nsec = 0;
  nsec = wr_sectors();  //    

  for (; ;)
    {
      len = lenfile();   //     
      printf("cyl = %d head = %d \n", ncyl, nhead);

      part[ahdd_part - ((nld - 2) * 2)] = nhead ^ (ncyl << 4);
      part[ahdd_part - 1 - ((nld - 2) * 2)] = len;

      nsec = wr_ld(); // / nsec     
      nsec = wr_sectors(); // 
      nsec = 0;

      fclose(rfp);

      bkd[0]++;
      nld++;
      ld_all = nld - 2;
      if ((rfp = fopen(bkd, "rb")) == NULL)
          break;
    }

  part[ahdd_ld_all] = ld_all ^ (boot << 8);
  part[ahdd_part - (ld_all * 2)] = crc_alt();  

  fseek(wfp, 0, SEEK_SET);
  invers_buf(mbr);
  if ((fwrite(mbr, 1, 512, wfp)) != 512)
      printf("    %s \n", img);

  fseek(wfp, 7 * 512, SEEK_SET);
  invers_buf(part);
  if ((fwrite(part, 1, 512, wfp)) != 512)
      printf("    %s \n", img);

  fclose(rfp);
  fclose(wfp);
}

//   hdd   ""
void bkd_img_sam()
{
  if ((rfp = fopen(bkd, "rb")) == NULL)
    {
      printf("   %s \n", bkd);
      exit(-1);
    }
  if ((wfp = fopen(img, "w+b")) == NULL)
    {
      printf("   %s \n", img);
      exit(-1);
    }

  part[shdd_boot] = boot;   // boot
  part[shdd_cyl] = cyl;
  part[shdd_head_sec] = head ^ (sec << 8);

  nsec = sec - 3;
  wr_sectors(); //  3  

  for (; ;)
    {
      len = lenfile();
      printf("lba = %ld len = %d \n", lba, len);

      for (int i = 0; i < 256; i++)
        if (p_invers == 0) buf[i] = 0; else buf[i] = 0177777;

      //     
      buf[shdd_nld] = nld;      //  ld
      buf[shdd_ld_len] = len;   //  ld
      buf[shdd_adr_boot] = 02000;   //    :)
      buf[shhd_adr_par] = 01000;    //     
      buf[shdd_page] = 014400;  //   

      part[(nld - 2) * 2 + 3] = lba;
      lba += len + 1;
      invers_buf(buf);

      if ((fwrite(buf, 1, 512, wfp)) != 512)
          printf("    %s \n", img);

      wr_ld(); 
      fclose(rfp);
      bkd[0]++;
      nld++;
      if ((rfp = fopen(bkd, "rb")) == NULL) break;
    }

  invers_buf(part);
  fseek(wfp, 512, SEEK_SET);
  if ((fwrite(part, 1, 512, wfp)) != 512)
      printf("    %s \n", img);

  fclose(rfp);
  fclose(wfp);
}

//      hdd ""    bkd 
void img_bkd_alt()
{
  if ((rfp = fopen(img, "rb")) == NULL)
    {
      printf("   %s \n", img);
      exit(-1);
    }

  fseek(rfp, 7 * 512, SEEK_SET);
  if ((fread(part, 1, 512, rfp)) != 512)
      printf("    %s \n", img);
  invers_buf(part);
  cyl = part[ahdd_cyl];
  head = part[ahdd_head];
  sec = part[ahdd_sec];
  ld_all = part[ahdd_ld_all] & 0377;

  printf("cyl = %d head = %d sec = %d  ld = %d \n", cyl, head, sec, ld_all);

  if (part[ahdd_part - (ld_all * 2)] != crc_alt())
    {
      printf("  %s    ''\n", img);
      exit(-1);
    }

  for (int i = 0; i < ld_all; i++)
    {
      ncyl = part[ahdd_part - ((nld - 2) * 2)] >> 4;
      nhead = part[ahdd_part - ((nld - 2) * 2)] & 0xF;
      lba = (ncyl * head + nhead) * sec * 512;
      len = part[ahdd_part - 1 - ((nld - 2) * 2)];
      printf("cyl = %d head = %d lba = %ld  len = %d \n", ncyl, nhead, lba, len);
      fseek(rfp, lba, SEEK_SET);

      if ((wfp = fopen(bkd, "w+b")) == NULL)
        {
          printf("   %s \n", bkd);
          exit(-1);
        }
      wr_bkd();
      fclose(wfp);
      bkd[0]++;
      nld++;
    }
  fclose(rfp);
}

//      hdd ""    bkd 
void img_bkd_sam()
{
  if ((rfp = fopen(img, "rb")) == NULL)
    {
      printf("   %s \n", img);
      exit(-1);
    }

  fseek(rfp, 512, SEEK_SET);
  if ((fread(part, 1, 512, rfp)) != 512)
      printf("    %s \n", img);
  invers_buf(part);
  cyl = part[shdd_cyl];
  head = part[shdd_head_sec] & 0377;
  sec = part[shdd_head_sec] >> 8;

  for (ld_all = 0; ld_all < 64; ld_all++)
    {
      lba = part[shdd_part + (ld_all * 2)];   //  
      if (lba == 0) break;
    }
  printf("cyl = %d head = %d sec = %d ld = %d\n", cyl, head, sec, ld_all);

  for (int i = 0; i < ld_all; i++)
    {
      lba = part[shdd_part + ((nld - 2) * 2)];
      printf("ld = %d lba = %ld \n", nld, lba);
      lba *= 512; 
      fseek(rfp, lba, SEEK_SET);

      if ((fread(buf, 1, 512, rfp)) != 512)
        {
          printf("    %s \n", img);
          exit(-1);
        }   
      invers_buf(buf);
      if (buf[shdd_nld] != nld)
        {
          printf("  %s    ''\n", img);
          exit(-1);
        }

      if ((wfp = fopen(bkd, "w+b")) == NULL)
        {
          printf("   %s \n", bkd);
          exit(-1);
        }
      len = buf[shdd_ld_len];
      wr_bkd();
      fclose(wfp);
      bkd[0]++;
      nld++;
    }
  fclose(rfp);
}

int main(int argc, char** argv)
{
  char format_hdd = 0;
  int ch;

  while ((ch = getopt(argc, argv, "amic:h:s:")) != -1)
      switch (ch)
        {
        case 'a':
          format_hdd = 'a';
          break;
        case 'm':
          format_hdd = 'm';
          break;
        case 'i':
          p_invers++;
          break;
        case 'c':
          cyl = strtol(optarg, 0, 0);
          break;
        case 'h':
          head = strtol(optarg, 0, 0);
          break;
        case 's':
          sec = strtol(optarg, 0, 0);
          break;
        default:
          helpdoc();
          exit(-1);
        }
  if (argc < 2)
    {
      helpdoc();
      exit(-1);
    }

  if (format_hdd == 'a')
    {
      if (sec == 0 && head == 0 && cyl == 0)
        {
          printf("\n   ''\n");
          img_bkd_alt();
        }
      else
        {
          printf("\n   ''\n");     
          printf("\n %d  %d  %d \n", cyl, head, sec);
          bkd_img_alt();
        }
    } 

  if (format_hdd == 'm')
    {
      if (sec == 0 && head == 0 && cyl == 0)
        {
          printf("\n   ''\n");
          img_bkd_sam();
        }
      else
        {
          printf("\n   ''\n");
          bkd_img_sam();
        }
    }
  return (0);
}

//TODO:
// -I (-f)     chs   
//      

